# __gnu_pbds Namespace Reference

GNU extensions for policy-based data structures for public use. More...

## Classes

- struct associative_container_tag
    Basic associative-container. More...
- class basic_hash_table
    An abstract basic hash-based associative container. More...
- struct basic_hash_tag
    Basic hash. More...
- class basic_tree
    An abstract basic tree-like (tree, trie) associative container. More...
- struct basic_tree_tag
    Basic tree. More...
- struct binary_heap_tag
    Binary-heap (array-based). More...
- struct binomial_heap_tag
    Binomial-heap. More...
- class cc_hash_table
    A concrete collision-chaining hash-based associative container. More...
- struct cc_hash_tag
    Collision-chaining hash. More...
- class container_base
    An abstract basic associative container. More...
- struct container_tag
    Base data structure tag. More...
- struct container_traits
    container_traits More...
- class gp_hash_table
    A concrete general-probing hash-based associative container. More...
- struct gp_hash_tag
    General-probing hash. More...
- class list_update
    A list-update based associative container. More...
- struct list_update_tag
    List-update. More...
- struct null_mapped_type
    A mapped-policy indicating that an associative container is a set. More...
- struct ov_tree_tag
    Ordered-vector tree. More...
- struct pairing_heap_tag
    Pairing-heap. More...
- struct pat_trie_tag
    PATRICIA trie. More...
- struct priority_queue_tag
    Basic priority-queue. More...
- struct rb_tree_tag
    Red-black tree. More...
- struct rc_binomial_heap_tag
    Redundant-counter binomial-heap. More...
- struct sequence_tag
    Basic sequence. More...
- struct splay_tree_tag
    Splay tree. More...
- struct string_tag
    Basic string container, inclusive of strings, ropes, etc. More...
- struct thin_heap_tag
    Thin heap. More...
- class tree
    A concrete basic tree-based associative container. More...
- struct tree_tag
    tree. More...
- class trie
    A concrete basic trie-based associative container. More...
- struct trie_tag
    trie. More...

## Typedefs

- typedef void trivial_iterator_difference_type

## Functions

- void __throw_container_error (void)
- void __throw_insert_error (void)
- void __throw_join_error (void)
- void __throw_resize_error (void)

## Detailed Description

GNU extensions for policy-based data structures for public use.